//@@LF 02.08.1999 Handler fuer ConsoleControl-Nachrichten eingebaut, damit der JunkBuster bei einem
//						System-Shutdown "gracefully" beendet wird (d.h. ohne MsgBox)

char *win32_rcs = "$Id: win32.c,v 1.12 (FIS) 1999/08/02 13:16:00 ACJC Exp $";
/* Written and copyright 1997 Anonymous Coders and Junkbusters Corporation.
 * Distributed under the GNU General Public License; see the README file.
 * This code comes with NO WARRANTY. http://www.junkbusters.com/ht/en/gpl.html
 */
#ifdef _WIN32

#include <stdio.h>
#ifdef REGEX
#include "gnu_regex.h"
#endif
#include "jcc.h"
#include <windows.h>

extern int hideConsole;

//@@LF 02.08.1999	Handler fuer ConsoleControlEvents hinzugefuegt. Der Handler gibt TRUE zurueck, wenn
// 					die Anwendung geschlossen werden soll und wenn das Anwendungsfenster unsichtbar
//						ist.
BOOL WINAPI CtrlHandler (DWORD dwEvent)
{
	switch (dwEvent) {
		case CTRL_LOGOFF_EVENT:
			printf("Got CTRL_LOGOFF_EVENT\n");
			if (hideConsole) {
				return (TRUE);
			}
			break;

		case CTRL_SHUTDOWN_EVENT:
			printf("Got CTRL_SHUTDOWN_EVENT\n");
			if (hideConsole) {
				return (TRUE);
			}
			break;

		case CTRL_CLOSE_EVENT:
			printf("Got CTRL_CLOSE_EVENT\n");
			if (hideConsole) {
				return (TRUE);
			}
			break;

		default:
			break;
	}

	// Handled all known events
	return (FALSE);
}

void InitWin32()
{
	WORD wVersionRequested;
	WSADATA wsaData;

	//@@LF 02.08.1999 Handler fuer ConsoleControl-Nachrichten anmelden
	SetConsoleCtrlHandler (CtrlHandler, TRUE);
	SetProcessShutdownParameters(0x100, SHUTDOWN_NORETRY);
	if (hideConsole) {
		FreeConsole();
	}

	wVersionRequested = MAKEWORD(2, 0);
	if (WSAStartup(wVersionRequested, &wsaData) != 0) {
		exit(1);
	}
}

char *win32_blurb =
"Internet Junkbuster Proxy(TM) Version " VERSION " for Windows is Copyright (C) 1997-8\n"
"by Junkbusters Corp.  This is free software; it may be used and copied under\n"
"the GNU General Public License: http://www.junkbusters.com/ht/en/gpl.html.\n"
"This program comes with ABSOLUTELY NO WARRANTY OF ANY KIND.\n"
"Win32 Code modified by FIS GmbH 1999 - no warranty given.\n"
"\n"
"For information about how to to configure the proxy and your browser, see\n"
"        http://www.junkbusters.com/ht/en/ijbwin.html#v" VERSION_MAJOR "\n"
"\n"
"The Internet Junkbuster Proxy(TM) is running and ready to serve!\n"
;
#endif
